//package neko;
//
// neko.java 0.2  05/18/96 by Kouji Ishida (kouji@vir.bekkoame.or.jp)
//
// Permission to use, copy, modify, and distribute this software.
// This program is a clone of 'neko DA' but algorithm is completely individual.
// The great freeware 'neko DA' is a Macintosh Desk Accessary program by Kenji Gotoh.
// Thanks to the author of the original program and image resourses.
//
// Development environment: JDK 1.0 by Sun Microsystems, Inc.
//                          teikade(dejava) 1.5b2 by PFU Limited.
//               Computer : ECHOS 24c olivetti.
//                     OS : Windows 95.
//
import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Event;
import java.awt.Image;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.MediaTracker;
import java.awt.FontMetrics;

public class neko extends Applet implements Runnable {
	static final double pi=3.14159265;
	static final int over=1;
	static final int under=2;
	static final int left=3;
	static final int right=4;
	int	pos;
	int x,y;	//mouse pos.
	int ox,oy;	//image pos.
	int dx,dy;	//image-mouse distance
	Image image[];	//images
	int no;		//image no.
	Thread thread;
	boolean move,out;	//mouse move, out flag
	int	init;	//for image loading initialize counter
	double	theta,dist;	//image-mouse polar data
	int	slp;	//sleep time
	int ilc1,ilc2;	//image loop counter
	MediaTracker mt;

    public String getAppletInfo() {
	return "neko.java by Kouji Ishida (kouji@vir.bekkoame.or.jp)";
    }

    /**
     * Called when the mouse exits the component.
     * @param evt the event
     * @param x the x coordinate
     * @param y the y coordinate
     * @see java.awt.Component#mouseExit
     */
    public boolean mouseExit(Event e, int x, int y) {
	out=true;
	return false;
    }

    /**
     * Called to start the applet. You never need to call this method
     * directly, it is called when the applet's document is visited.
     * @see java.applet.Applet#start
     */
    public void start() {
	if (thread==null){
		thread=new Thread(this);
		thread.start();
	}
    }

    /**
     * Called to stop the applet. It is called when the applet's document is
     * no longer on the screen. It is guaranteed to be called before destroy()
     * is called. You never need to call this method directly.
     * @see java.applet.Applet#stop
     */
    public void stop() {
	if(thread != null){
		thread.stop();
		thread=null;
	}
    }

    /**
     * Initializes the applet.
     * You never need to call this directly, it is called automatically
     * by the system once the applet is created.
     * @see java.applet.Applet#init
     */
    public void init() {
    String arg = getParameter("COLOR");
    if(arg == null){arg = "ffffff";}
	setBackground(new Color(Integer.parseInt(arg,16)));
	image=new Image[33];
	mt = new MediaTracker(this);
	for (int i=1;i<33;i++){
		image[i]=getImage(getCodeBase(),"images/"+i+".gif");
		showStatus(getCodeBase()+"images/"+i+".gif");
		mt.addImage(image[i],0);
	}
	move=false; out=false;
	slp=200;
	init=1;
	ilc1=0; ilc2=0; pos=0;
    }

    /**
     * Paints the component.
     * @param g the specified Graphics window
     * @see java.awt.Component#paint
     */
    public void paint(Graphics g) {
		if(!mt.checkID(0)){
			String s = new String("Image loading...");
			showStatus(s);
			Dimension r=size();
			FontMetrics fm = g.getFontMetrics();
			int sWidth = fm.stringWidth(s);
			int sHeight = fm.getHeight();
			g.drawString(s,(r.width-sWidth)/2,(r.height-sHeight)/2);
			return;
		}
		g.drawImage(image[no],ox-16,oy-32,this);
	}

    /**
     * Called if the mouse moves (the mouse button is up)
     * @param evt the event
     * @param x the x coordinate
     * @param y the y coordinate
     * @see java.awt.Component#mouseMove
     */
    public boolean mouseMove(Event e, int x, int y) {
	this.x=x;
	this.y=y;
	if (y < 32){this.y = 32; pos=over;}
	if (y >= size().height-2){pos=under;}
	if (x < 16){this.x = 16; pos=left;} 
	if (x >= size().width - 16){this.x = size().width - 16; pos=right;}
	if (mt.checkID(0)){showStatus("("+x+","+y+")");}
	dx=this.x-ox; dy=oy-this.y;
	dist=Math.sqrt(dx*dx+dy*dy);
	theta=Math.atan2(dy,dx);
	move=true; out=false;
	slp=200;
	return false;
    }

    /**
     * java.lang.Runnable stuff
     */
    public void run()  {
	try{
		mt.waitForID(0);
	}catch(InterruptedException e){
		return;
	}
	while(true){
		try {
			Thread.sleep(slp);
		}catch (InterruptedException e){
			break;
		}
		if(dist>16){
			slp=200;
			ox=(int)(ox+Math.cos(theta)*16);
			oy=(int)(oy-Math.sin(theta)*16);
			dist=dist-16;
			if (theta >=  -pi/8 && theta <=   pi/8 ) { no= (no== 5) ?  6 :  5;}
			if (theta >    pi/8 && theta <  3*pi/8 ) { no= (no== 3) ?  4 :  3;}
			if (theta >= 3*pi/8 && theta <= 5*pi/8 ) { no= (no== 1) ?  2 :  1;}
			if (theta >  5*pi/8 && theta <  7*pi/8 ) { no= (no==15) ? 16 : 15;}
			if (theta >= 7*pi/8 || theta <=-7*pi/8 ) { no= (no==13) ? 14 : 13;}
			if (theta > -7*pi/8 && theta < -5*pi/8 ) { no= (no==11) ? 12 : 11;}
			if (theta >=-5*pi/8 && theta <=-3*pi/8 ) { no= (no== 9) ? 10 :  9;}
			if (theta > -3*pi/8 && theta <   -pi/8 ) { no= (no== 7) ?  8 :  7;}
			
			move=false;
		}else{
			ox=x; oy=y; slp=400;
			switch(no){
				case 25:
					if(out==true){
						switch(pos){
							case over:  no=17; break;
							case under: no=21; break;
							case left:  no=23; break;
							case right: no=19; break;
							default: no=31; break;
						} pos=0; break;
					} no=31; break;
				case 17: no=18; ilc1++; if(ilc1==6){ no=27; ilc1=0;} break;
				case 18: no=17; break;
				case 21: no=22; ilc1++; if(ilc1==6){ no=27; ilc1=0;} break;
				case 22: no=21; break;
				case 23: no=24; ilc1++; if(ilc1==6){ no=27; ilc1=0;} break;
				case 24: no=23; break;
				case 19: no=20; ilc1++; if(ilc1==6){ no=27; ilc1=0;} break;
				case 20: no=19; break;
				
				case 31: no=25; ilc1++; if(ilc1==6){ no=27; ilc1=0;} break;
				case 27: no=28; break;
				case 28: no=27; ilc2++; if(ilc2==4){ no=26; ilc2=0;} break;
				case 26: no=29; break;
				case 29: no=30; break;
				case 30: no=29; break;
				default: no=25; break;
			}
			if (move==true){
				no=32;ilc1=0;ilc2=0;
				move=false;
			}
		}
		if (init<33){
			slp=200;
			ox=size().width/2;oy=size().height/2;no=init;
			init++; showStatus("Warming-up..."+String.valueOf(init));
			if (init==33){showStatus("Complete.");}
		}
		repaint();
    }
    }
}
